addHook("AbilitySpecial", function(player)
	if player.mo.skin == "usbsonic"
		if not (player.pflags & PF_THOKKED)
			player.pflags = $1 & ~PF_JUMPED
			P_Thrust(player.mo, player.mo.angle, 20*FRACUNIT)
			S_StartSound(player.mo, sfx_thok)
			P_SetObjectMomZ(player.mo,2*FRACUNIT)
			local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
			thok.color = player.mo.color
			player.pflags = $1|PF_THOKKED|PF_SPINNING
		end
	end
end)


--walljump script redone /helped made by @CloneFighter#8017/@L_CloneFighter-v2.pk3#8017

addHook("MobjMoveBlocked", function(pmo, _, line) local player = pmo.player
	if not line then return end
	
	if pmo.skin == "usbsonic" then
		player.jumpwall = line
	end
end, MT_PLAYER)

addHook("PlayerThink", function(player) local mo = player.mo
	if player.mo.skin != "usbsonic" then return end
	
	player.walljumptimer = $ or 0
	if (player.jumpwall or player.walljumping) and not P_IsObjectOnGround(mo) then
		P_SetObjectMomZ(mo, (mo.eflags & MFE_UNDERWATER) and FRACUNIT/8 or FRACUNIT/3, true)
		mo.state = S_PLAY_SPINDASH
		player.pflags = $|PF_THOKKED
		
		if player.walljumping == 1
			mo.state = S_PLAY_FALL
			player.pflags = ($|PF_THOKKED) & ~PF_JUMPED
			player.walljumping = 0
			return
		end
		
		if player.jumpwall then
			if not player.walljumping then player.walljumptimer = 13 end
			player.walljumping = 12
			
			local wallx, wally = P_ClosestPointOnLine(mo.x,mo.y, player.jumpwall)
			player.wallang = R_PointToAngle2(wallx,wally, mo.x,mo.y)
			player.drawangle = player.wallang - ANGLE_180
			P_SpawnSkidDust(player, 20*FRACUNIT, sfx_s3k7e)
			
			if player.walljumptimer <= 0 then
				if player.cmd.buttons & BT_JUMP then
					P_SetObjectMomZ(mo, (mo.eflags & MFE_UNDERWATER) and FRACUNIT*6 or FRACUNIT*16)
					P_Thrust(mo, player.wallang, (mo.eflags & MFE_UNDERWATER) and FRACUNIT*8 or FRACUNIT*22)
					player.mo.angle = player.wallang
					player.drawangle = player.wallang
					
					for i = 1, 10 do
						P_SpawnSkidDust(player, 40*FRACUNIT)
					end
					mo.state = S_PLAY_JUMP
					player.pflags = ($|PF_JUMPED) & ~PF_THOKKED
					S_StartSound(mo, sfx_zoom)
					S_StartSound(mo, sfx_jump)
					player.walljumping = 0
				elseif player.cmd.buttons & BT_SPIN then
					P_Thrust(mo, player.wallang, (mo.eflags & MFE_UNDERWATER) and FRACUNIT*3 or FRACUNIT*7)
					mo.state = S_PLAY_JUMP
					player.pflags = ($|PF_JUMPED) & ~PF_THOKKED
					player.walljumping = 0
				end
			end
		end
	end
	
	if P_IsObjectOnGround(mo) then player.walljumping = 0 end
	
	if player.walljumptimer > 0 then player.walljumptimer = $-1 end
	if player.walljumping > 0 then player.walljumping = $-1 end
	player.jumpwall = nil
end)